import { ViewGenerator } from "./decorator/mvc/ViewGenerator";
import { RequestHandler } from "./decorator/mvc/RequestHandler";
import { Controller } from "./decorator/mvc/Controller";
import { ApplicationDescriptor } from "./decorator/configuration/ApplicationDescriptor";
import { ApplicationDescriptorProcessor } from "./decorator/processor/ApplicationDescriptorProcessor";
import { Configuration } from "./core/model/Configuration";
import { Configurator } from "./decorator/configuration/Configurator";
import { TemplateEngine } from "./enum/TemplateEngine";

@Controller()
class TestController {

    @RequestHandler( "/test" )
    @ViewGenerator()
    public test(): string {
        return "test.html";
    }

}

@ApplicationDescriptor()
class AutumnApplicationExample {

    @Configurator()
    public configurator(): Configuration {

        return new Configuration(
            5846,
            [ TestController ],
            null,
            "views",
            TemplateEngine.NONE
        );

    }

}

ApplicationDescriptorProcessor.process( new AutumnApplicationExample() );